Index: libcfa/src/bits/locks.hfa
===================================================================
--- libcfa/src/bits/locks.hfa	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ libcfa/src/bits/locks.hfa	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -283,9 +283,4 @@
 		void ^?{}(future_t &) {}
 
-		void reset(future_t & this) {
-			// needs to be in 0p or 1p
-			__atomic_exchange_n( &this.ptr, 0p, __ATOMIC_SEQ_CST);
-		}
-
 		// check if the future is available
 		bool available( future_t & this ) {
@@ -345,12 +340,6 @@
 
 		// Mark the future as abandoned, meaning it will be deleted by the server
-		bool abandon( future_t & this ) {
-			/* paranoid */ verify( this.ptr != 3p );
-
-			// Mark the future as abandonned
+		void abandon( future_t & this ) {
 			struct oneshot * got = __atomic_exchange_n( &this.ptr, 3p, __ATOMIC_SEQ_CST);
-
-			// If the future isn't already fulfilled, let the server delete it
-			if( got == 0p ) return false;
 
 			// got == 2p: the future is ready but the context hasn't fully been consumed
@@ -358,11 +347,6 @@
 			if( got == 2p ) {
 				while( this.ptr != 1p ) Pause();
-				got = 1p;
-			}
-
-			// The future is completed delete it now
-			/* paranoid */ verify( this.ptr != 1p );
-			free( &this );
-			return true;
+			}
+			return;
 		}
 
Index: libcfa/src/bits/queue.hfa
===================================================================
--- libcfa/src/bits/queue.hfa	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ libcfa/src/bits/queue.hfa	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -3,11 +3,5 @@
 #include "bits/collection.hfa"
 
-// A Queue(T) is a Collection(T) defining the ordering that nodes are returned by drop() in the same order from those
-// added by add(). T must be a public descendant of uColable.
-
-// The implementation is a typical singly-linked list, except the next field of the last element points to itself
-// instead of being null.
-
-forall( dtype T | { T *& Next ( T * ); } ) {
+forall( dtype T ) {
 	struct Queue {
 		inline Collection;								// Plan 9 inheritance
@@ -40,5 +34,5 @@
 		} // post: n == tail() & succ(n) == 0 | n != tail() & *succ(n) in *q
 
-		T & addHead( Queue(T) & q, T & n ) with( q ) {
+		void addHead( Queue(T) & q, T & n ) with( q ) {
 			#ifdef __CFA_DEBUG__
 			if ( listed( &n ) ) abort( "(Queue &)%p.addHead( %p ) : Node is already on another list.", &q, &n );
@@ -51,8 +45,7 @@
 				Next( &n ) = &n;						// last node points to itself
 			}
-			return n;
 		}
 
-		T & addTail( Queue(T) & q, T & n ) with( q ) {
+		void addTail( Queue(T) & q, T & n ) with( q ) {
 			#ifdef __CFA_DEBUG__
 			if ( listed( &n ) ) abort( "(Queue &)%p.addTail( %p ) : Node is already on another list.", &q, &n );
@@ -62,9 +55,8 @@
 			last = &n;
 			Next( &n ) = &n;							// last node points to itself
-			return n;
 		}
 
-		T & add( Queue(T) & q, T & n ) with( q ) {
-			return addTail( q, n );
+		void add( Queue(T) & q, T & n ) with( q ) {
+			addTail( q, n );
 		}
 
@@ -72,5 +64,5 @@
 			T & t = head( q );
 			if ( root ) {
-				root = Next( (T *)root );
+				root = Next( root );
 				if ( &head( q ) == &t ) {
 					root = last = 0p;					// only one element
@@ -85,5 +77,5 @@
 		}
 
-		T & remove( Queue(T) & q, T & n ) with( q ) {	// O(n)
+		void remove( Queue(T) & q, T & n ) with( q ) {	// O(n)
 			#ifdef __CFA_DEBUG__
 			if ( ! listed( (Colable &)n ) ) abort( "(Queue &)%p.remove( %p ) : Node is not on a list.", &q, &n );
@@ -111,8 +103,7 @@
 				curr = Next( curr );
 			}
-			return n;
 		} // post: ! listed( n )
 
-		T & dropTail( Queue(T) & q ) with( q ) {		// O(n)
+		T & dropTail( Queue(T) & q ) with( q ) { // O(n)
 			T & n = tail( q );
 			return &n ? remove( q, n ), n : *0p;
@@ -151,5 +142,5 @@
 } // distribution
 
-forall( dtype T | { T *& Next ( T * ); } ) {
+forall( dtype T ) {
 	struct QueueIter {
 		inline ColIter;									// Plan 9 inheritance
@@ -161,5 +152,5 @@
 		} // post: curr == 0p
 
-		// create an iterator active in queue q
+		// create an iterator active in Queue q
 		void ?{}( QueueIter(T) & qi, Queue(T) & q ) with( qi ) {
 			curr = &head( q );
@@ -170,10 +161,10 @@
 		} // post: curr = {e in q}
 
-		// make existing iterator active in queue q
+		// make existing iterator active in Queue q
 		void over( QueueIter(T) & qi, Queue(T) & q ) with( qi ) {
 			curr = &head( q );
 		} // post: curr = {e in q}
 
-		bool ?|?( QueueIter(T) & qi, T && tp ) with( qi ) {
+		bool ?>>?( QueueIter(T) & qi, T && tp ) with( qi ) {
 			if ( curr ) {
 				&tp = Curr( qi );
@@ -183,5 +174,5 @@
 			return &tp != 0p;
 		}
-		// post: elts == null & !operator|(tp) | elts != null & *tp' in elts & elts' == elts - *tp & operator|(tp)
+		// post: elts == null & !operator>>(tp) | elts != null & *tp' in elts & elts' == elts - *tp & operator>>(tp)
 	} // distribution
 } // distribution
Index: libcfa/src/bits/sequence.hfa
===================================================================
--- libcfa/src/bits/sequence.hfa	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ libcfa/src/bits/sequence.hfa	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -2,13 +2,11 @@
 
 #include "bits/collection.hfa"
-#include "bits/defs.hfa"
 
 struct Seqable {
-	__cfa_anonymous_object(Colable);
-	struct Seqable * back;										// pointer to previous node in the list
+	inline Colable;
+	Seqable * back;										// pointer to previous node in the list
 };
 
-#ifdef __cforall
-static inline {
+inline {
 	// PUBLIC
 
@@ -28,25 +26,18 @@
 	}
 
-	// // wrappers to make Collection have T
-	// forall( dtype T ) {
-	// 	T *& Back( T * n ) {
-	// 		return (T *)Back( (Seqable *)n );
-	// 	}
-	// } // distribution
+	// wrappers to make Collection have T
+	forall( dtype T ) {
+		T *& Back( T * n ) {
+			return (T *)Back( (Seqable *)n );
+		}
+	} // distribution
 } // distribution
 
-
-// A Sequence(T) is a Collection(T) defining the ordering of a uStack and uQueue, and to insert and remove elements
-// anywhere in the sequence. T must be a public descendant of uSeqable.
-
-// The implementation is a typical doubly-linked list, except the next field of the last node points at the first node
-// and the back field of the last node points at the first node (circular).
-
-forall( dtype T | { T *& Back ( T * ); T *& Next ( T * ); } ) {
+forall( dtype T ) {
 	struct Sequence {
 		inline Collection;								// Plan 9 inheritance
 	};
 
-	static inline {
+	inline {
 		// wrappers to make Collection have T
 		T & head( Sequence(T) & s ) with( s ) {
@@ -59,7 +50,7 @@
 		void ?{}( Sequence(T) & s ) with( s ) {	
 			((Collection &)s){};
-		}	// post: isEmpty()
-
-		// Return a pointer to the last sequence element, without removing it.
+		}	// post: isEmpty().
+
+		// Return a pointer to the last sequence element, without removing it.	
 		T & tail( Sequence(T) & s ) with( s ) {
 			return root ? (T &)*Back( &head( s ) ) : *0p;
@@ -74,5 +65,5 @@
 		} // post: n == tail() & succ(n) == 0 | n != tail() & *succ(n) in *s
 
-		// Return a pointer to the element before *n, or 0p if list empty.
+		// Return a pointer to the element before *n, or 0p if there isn't one.
 		T * pred( Sequence(T) & s, T * n ) with( s ) {	// pre: *n in *s
 			#ifdef __CFA_DEBUG__
@@ -80,9 +71,9 @@
 			#endif // __CFA_DEBUG__
 			return n == &head( s ) ? 0p : Back( n );
-		} // post: n == head() & head(n) == 0 | n != head() & *pred(n) in *s
-
-
-		// Insert *n into the sequence before *bef, or at the end if bef == 0p.
-		T & insertBef( Sequence(T) & s, T & n, T & bef ) with( s ) { // pre: !n->listed() & *bef in *s
+		}	// post: n == head() & head(n) == 0 | n != head() & *pred(n) in *s
+
+
+		// Insert *n into the sequence before *bef, or at the end if bef == 0.
+		void insertBef( Sequence(T) & s, T & n, T & bef ) with( s ) { // pre: !n->listed() & *bef in *s
 			#ifdef __CFA_DEBUG__
 			if ( listed( &n ) ) abort( "(Sequence &)%p.insertBef( %p, %p ) : Node is already on another list.", &s, n, &bef );
@@ -112,10 +103,9 @@
 				Next( Back( &n ) ) = &n;
 			} // if
-			return n;
 		}	// post: n->listed() & *n in *s & succ(n) == bef
 
 
 		// Insert *n into the sequence after *aft, or at the beginning if aft == 0.
-		T & insertAft( Sequence(T) & s, T & aft, T & n ) with( s ) {	// pre: !n->listed() & *aft in *s
+		void insertAft( Sequence(T) & s, T & aft, T & n ) with( s ) {	// pre: !n->listed() & *aft in *s
 			#ifdef __CFA_DEBUG__
 			if ( listed( &n ) ) abort( "(Sequence &)%p.insertAft( %p, %p ) : Node is already on another list.", &s, &aft, &n );
@@ -143,9 +133,8 @@
 				Next( &aft ) = &n;
 			} // if
-			return n;
-		} // post: n->listed() & *n in *s & succ(n) == bef
+		}	  // post: n->listed() & *n in *s & succ(n) == bef
 		
 		// pre: n->listed() & *n in *s
-		T & remove( Sequence(T) & s, T & n ) with( s ) { // O(1)
+		void remove( Sequence(T) & s, T & n ) with( s ) { // O(1)
 			#ifdef __CFA_DEBUG__
 			if ( ! listed( &n ) ) abort( "(Sequence &)%p.remove( %p ) : Node is not on a list.", &s, &n );
@@ -158,22 +147,18 @@
 			Next( Back( &n ) ) = Next( &n );
 			Next( &n ) = Back( &n ) = 0p;
-			return n;
-		} // post: !n->listed()
+		}							// post: !n->listed().
 
 		// Add an element to the head of the sequence.
-		T & addHead( Sequence(T) & s, T & n ) {			// pre: !n->listed(); post: n->listed() & head() == n
-			return insertAft( s, *0p, n );
-		}
-
+		void addHead( Sequence(T) & s, T & n ) {		// pre: !n->listed(); post: n->listed() & head() == n
+			insertAft( s, *0p, n );
+		}
 		// Add an element to the tail of the sequence.
-		T & addTail( Sequence(T) & s, T & n ) {			// pre: !n->listed(); post: n->listed() & head() == n
-			return insertBef( s, n, *0p );
-		}
-
+		void addTail( Sequence(T) & s, T & n ) {		// pre: !n->listed(); post: n->listed() & head() == n
+			insertBef( s, n, *0p );
+		}
 		// Add an element to the tail of the sequence.
-		T & add( Sequence(T) & s, T & n ) {				// pre: !n->listed(); post: n->listed() & head() == n
-			return addTail( s, n );
-		}
-
+		void add( Sequence(T) & s, T & n ) {			// pre: !n->listed(); post: n->listed() & head() == n
+			addTail( s, n );
+		}
 		// Remove and return the head element in the sequence.
 		T & dropHead( Sequence(T) & s ) {
@@ -181,10 +166,8 @@
 			return &n ? remove( s, n ), n : *0p;
 		}
-
 		// Remove and return the head element in the sequence.
 		T & drop( Sequence(T) & s ) {
 			return dropHead( s );
 		}
-
 		// Remove and return the tail element in the sequence.
 		T & dropTail( Sequence(T) & s ) {
@@ -201,7 +184,7 @@
 				T * toEnd = Back( &head( s ) );
 				T * fromEnd = Back( &head( from ) );
-				Back( (T *)root ) = fromEnd;
+				Back( root ) = fromEnd;
 				Next( fromEnd ) = &head( s );
-				Back( (T *)from.root ) = toEnd;
+				Back( from.root ) = toEnd;
 				Next( toEnd ) = &head( from );
 			} // if
@@ -231,5 +214,5 @@
 } // distribution
 
-forall( dtype T | { T *& Back ( T * ); T *& Next ( T * ); } ) {
+forall( dtype T ) {
 	// SeqIter(T) is used to iterate over a Sequence(T) in head-to-tail order.
 	struct SeqIter {
@@ -241,16 +224,15 @@
 	};
 
-	static inline {
+	inline {
 		void ?{}( SeqIter(T) & si ) with( si ) {
 			((ColIter &)si){};
 			seq = 0p;
-		} // post: elts = null
-
-		// Create a iterator active in sequence s.
+		} // post: elts = null.
+
 		void ?{}( SeqIter(T) & si, Sequence(T) & s ) with( si ) {
 			((ColIter &)si){};
 			seq = &s;
 			curr = &head( s );
-		} // post: elts = null
+		} // post: elts = null.
 
 		void ?{}( SeqIter(T) & si, Sequence(T) & s, T & start ) with( si ) {
@@ -258,13 +240,12 @@
 			seq = &s;
 			curr = &start;
-		} // post: elts = null
-
-		// Make the iterator active in sequence s.
+		} // post: elts = null.
+
 		void over( SeqIter(T) & si, Sequence(T) & s ) with( si ) {
 			seq = &s;
 			curr = &head( s );
-		} // post: elts = {e in s}
-
-		bool ?|?( SeqIter(T) & si, T && tp ) with( si ) {
+		} // post: elts = {e in s}.
+
+		bool ?>>?( SeqIter(T) & si, T && tp ) with( si ) {
 			if ( curr ) {
 				&tp = Curr( si );
@@ -284,16 +265,15 @@
 	};
 
-	static inline {
+	inline {
 		void ?{}( SeqIterRev(T) & si ) with( si ) {	
 			((ColIter &)si){};
 			seq = 0p;
-		} // post: elts = null
-
-		// Create a iterator active in sequence s.
+		} // post: elts = null.
+
 		void ?{}( SeqIterRev(T) & si, Sequence(T) & s ) with( si ) {	
 			((ColIter &)si){};
 			seq = &s;
 			curr = &tail( s );
-		} // post: elts = null
+		} // post: elts = null.
 
 		void ?{}( SeqIterRev(T) & si, Sequence(T) & s, T & start ) with( si ) {	
@@ -301,13 +281,12 @@
 			seq = &s;
 			curr = &start;
-		} // post: elts = null
-
-		// Make the iterator active in sequence s.
+		} // post: elts = null.
+
 		void over( SeqIterRev(T) & si, Sequence(T) & s ) with( si ) {
 			seq = &s;
 			curr = &tail( s );
-		} // post: elts = {e in s}
-
-		bool ?|?( SeqIterRev(T) & si, T && tp ) with( si ) {
+		} // post: elts = {e in s}.
+
+		bool ?>>?( SeqIterRev(T) & si, T && tp ) with( si ) {
 			if ( curr ) {
 				&tp = Curr( si );
@@ -319,4 +298,2 @@
 	} // distribution
 } // distribution
-
-#endif
Index: libcfa/src/bits/stack.hfa
===================================================================
--- libcfa/src/bits/stack.hfa	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ libcfa/src/bits/stack.hfa	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -3,11 +3,5 @@
 #include "bits/collection.hfa"
 
-// A Stack(T) is a Collection(T) defining the ordering that nodes are returned by drop() in the reverse order from those
-// added by add(). T must be a public descendant of uColable.
-
-// The implementation is a typical singly-linked list, except the next field of the last element points to itself
-// instead of being null.
-
-forall( dtype T | { T *& Next ( T * ); } ) {
+forall( dtype T ) {
 	struct Stack {
 		inline Collection;								// Plan 9 inheritance
@@ -31,5 +25,5 @@
 		}
 
-		T & addHead( Stack(T) & s, T & n ) with( s ) {
+		void addHead( Stack(T) & s, T & n ) with( s ) {
 			#ifdef __CFA_DEBUG__
 			if ( listed( (Colable &)(n) ) ) abort( "(Stack &)%p.addHead( %p ) : Node is already on another list.", &s, n );
@@ -37,13 +31,12 @@
 			Next( &n ) = &head( s ) ? &head( s ) : &n;
 			root = &n;
-			return n;
 		}
 
-		T & add( Stack(T) & s, T & n ) with( s ) {
-			return addHead( s, n );
+		void add( Stack(T) & s, T & n ) with( s ) {
+			addHead( s, n );
 		}
 
-		T & push( Stack(T) & s, T & n ) with( s ) {
-			return addHead( s, n );
+		void push( Stack(T) & s, T & n ) with( s ) {
+			addHead( s, n );
 		}
 
@@ -51,5 +44,5 @@
 			T & t = head( s );
 			if ( root ) {
-				root = ( T *)Next( (T *)root );
+				root = ( T *)Next( root );
 				if ( &head( s ) == &t ) root = 0p;		// only one element ?
 				Next( &t ) = 0p;
@@ -64,8 +57,6 @@
 } // distribution
 
-// A StackIter(T) is a subclass of ColIter(T) that generates the elements of a Stack(T).  It returns the elements in the
-// order returned by drop().
 
-forall( dtype T | { T *& Next ( T * ); } ) {
+forall( dtype T ) {
 	struct StackIter {
 		inline ColIter;									// Plan 9 inheritance
@@ -77,5 +68,5 @@
 		} // post: curr == 0p
 
-		// create an iterator active in stack s
+		// create an iterator active in Stack s
 		void ?{}( StackIter(T) & si, Stack(T) & s ) with( si ) {
 			curr = &head( s );
@@ -86,10 +77,10 @@
 		} // post: curr = {e in s}
 
-		// make existing iterator active in stack s
+		// make existing iterator active in Stack q
 		void over( StackIter(T) & si, Stack(T) & s ) with( si ) {
 			curr = &head( s );
 		} // post: curr = {e in s}
 
-		bool ?|?( StackIter(T) & si, T && tp ) with( si ) {
+		bool ?>>?( StackIter(T) & si, T && tp ) with( si ) {
 			if ( curr ) {
 				&tp = Curr( si );
Index: libcfa/src/concurrency/invoke.h
===================================================================
--- libcfa/src/concurrency/invoke.h	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ libcfa/src/concurrency/invoke.h	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -189,10 +189,4 @@
 		struct __monitor_group_t monitors;
 
-		// used to put threads on user data structures
-		struct {
-			struct $thread * next;
-			struct $thread * back;
-		} seqable;
-
 		struct {
 			struct $thread * next;
@@ -224,16 +218,4 @@
 		}
 
-		static inline $thread *& Back( $thread * this ) __attribute__((const)) {
-			return this->seqable.back;
-		}
-
-		static inline $thread *& Next( $thread * this ) __attribute__((const)) {
-			return this->seqable.next;
-		}
-
-		static inline bool listed( $thread * this ) {
-			return this->seqable.next != 0p;
-		}
-
 		static inline void ?{}(__monitor_group_t & this) {
 			(this.data){0p};
Index: libcfa/src/concurrency/kernel/startup.cfa
===================================================================
--- libcfa/src/concurrency/kernel/startup.cfa	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ libcfa/src/concurrency/kernel/startup.cfa	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -118,5 +118,4 @@
 
 extern size_t __page_size;
-extern int __map_prot;
 
 //-----------------------------------------------------------------------------
@@ -726,10 +725,4 @@
 		}
 	#else
-		__cfaabi_dbg_debug_do(
-			// pthread has no mechanism to create the guard page in user supplied stack.
-			if ( mprotect( stack, __page_size, __map_prot ) == -1 ) {
-				abort( "mprotect : internal error, mprotect failure, error(%d) %s.", errno, strerror( errno ) );
-			} // if
-		);
 		free( stack );
 	#endif
